// multiprint.cpp  NEEDS WORK
// Glenn G. Chappell
// 31 Oct 2013
//
// For CS 202 Fall 2013
// Exceptions & Function Templates

#include <iostream>
using std::cout;
using std::endl;
using std::cin;
#include <stdexcept>
using std::domain_error;


// Write function template "multiPrint" here!!!


int main()
{
    cout << "Should print \"abc\" two times:" << endl;
    try
    {
        multiPrint(2, "abc");
    }
    catch (domain_error & e)
    {
        cout << "OOPS! Exception thrown!" << endl;
    }
    catch (...)
    {
        cout << "DOUBLE OOPS! Exception of unknown type thrown!" << endl;
    }
    cout << endl;

    cout << "Should print \"42\" three times:" << endl;
    try
    {
        multiPrint(3, 42);
    }
    catch (domain_error & e)
    {
        cout << "OOPS! Exception thrown!" << endl;
    }
    catch (...)
    {
        cout << "DOUBLE OOPS! Exception of unknown type thrown!" << endl;
    }
    cout << endl;

    cout << "Should print an error message:" << endl;
    try
    {
        multiPrint(-7, 100.0);
        cout << "OOPS! No exception thrown!" << endl;
    }
    catch (domain_error & e)
    {
        cout << "Error message - multiPrint threw, as expected" << endl;
        cout << "Associated string: " << e.what() << endl;
    }
    catch (...)
    {
        cout << "DOUBLE OOPS! Exception of unknown type thrown!" << endl;
    }
    cout << endl;

    cout << "Press ENTER to quit ";
    while (cin.get() != '\n') ;

    return 0;
}

